// Constructor.
function MainLabel(id, text){
	if (id != UI_NO_INIT_ID) {
		this.init(id, text);
	}
}

// MainLabel inherits from Control.
MainLabel.prototype = new Control(UI_NO_INIT_ID);

// Content element for MainLabel text.
MainLabel.prototype.contentElement = null;

// Initializer - called from constructor.
MainLabel.prototype.init = function(id, text){
	// call superclass initializer
	Control.prototype.init.call(this, id, null);
	
	// create content element
	this.contentElement = document.createElement("div");
	this.controlElement.appendChild(this.contentElement);
	
	// set the text
	this.setText(text);
}


// Returns the control text.
MainLabel.prototype.getText = function(){
	return this.contentElement.innerHTML;
}

// Sets the text for the control.
MainLabel.prototype.setText = function(text){
	this.contentElement.innerHTML = (text == null) ? "" : text;
	this.updateStyleFromState();
}

// Updates the style of the control to reflects the state of the control.
MainLabel.prototype.updateStyleFromState = function(){
	/*
	 this.setClassName(this.rootElement, "Control");
	 this.setClassName(this.assemblyElement, "ControlAssembly ControlAssemblyNormal");
	 this.setClassName(this.captionElement, "ControlCaption ControlCaptionNormal");
	 this.setClassName(this.controlElement, "ControlElement");
	 this.setClassName(this.contentElement, "MainLabelText");
	 */
}
