var phonebook = null;

var uiManager;

var mainView;
var buttons = [];

var aboutView;
var lb_about;
var lb_info;
var separator;
var separator2;
var baloonLabel;

var setupView;
var titleFormatList;
var dateFormatList;

var miniView;


var DATE_FORMAT_DD_MM_YYYY = 0;
var DATE_FORMAT_MM_DD_YYYY = 1;
var DATE_FORMAT_YYYY_MM_DD = 2;

var dateFormates = 
[
 { value: DATE_FORMAT_DD_MM_YYYY, text: LOC_dfDDMMYYYY}, 
 { value: DATE_FORMAT_MM_DD_YYYY, text: LOC_dfMMDDYYYY}, 
 { value: DATE_FORMAT_YYYY_MM_DD, text: LOC_dfYYYYMMDD}, 
];

var TITLE_FORMAT_LAST_FIRST = 0;
var TITLE_FORMAT_FIRST_LAST = 1;

var titleFormates = 
[
 { value: TITLE_FORMAT_LAST_FIRST, text: LOC_tfLastFirst}, 
 { value: TITLE_FORMAT_FIRST_LAST, text: LOC_tfFirstLast}, 
];

var MENU_ITEM_ABOUT   = 0;
var MENU_ITEM_REFRESH = 1;
var MENU_ITEM_SETUP   = 2;
var MENU_ITEM_CANCEL  = 3;

var titleFormat = 0;
var dateFormat = 0;

var setup_titleFormat = 0;
var setup_dateFormat = 0;

var updateTimerId = null;

var sizeState = null;

var persons = [];


function init(){
    if (window.widget) {
        widget.setNavigationEnabled(false);
        menu.showSoftkeys();
		
		var tmp = widget.preferenceForKey("titleFormat");
		titleFormat = tmp != undefined ? tmp : 0;
		
		tmp = widget.preferenceForKey("dateFormat");
		dateFormat = tmp != undefined ? tmp : 0;
		
        setup_titleFormat = titleFormat; 
        setup_dateFormat  = dateFormat; 
    }
    
    uiManager = new UIManager( null, null, true );
	
    mainView = new ListView(null, LOC_upcomingBirthdays);
    
    aboutView = new ListView(null, LOC_aboutTitle);
    lb_about = new Label(null, null, LOC_about);
    aboutView.addControl(lb_about);
    separator = new Separator(null);
    aboutView.addControl(separator);
    lb_info = new Label(null, null, LOC_info);
    aboutView.addControl(lb_info);
    separator2 = new Separator(null);
    aboutView.addControl( separator2 );	
	var rawBaloonInfo = "<TABLE BORDER=0 WIDTH=\"100%\" style=\"font-size: 20px;\"><TR><TD><img src=\"baloon.png\"/></TD><TD>" + LOC_lessThanWeek + "</TD></TR><TR><TD><img src=\"baloon_middle.png\"/></TD><TD>" + LOC_lessThan3Week + "</TD> </TR><TR><TD><img src=\"baloon_long.png\"/></TD><TD>" + LOC_moreThan3Week + "</TD></TR></TABLE>";
	baloonLabel = new MainLabel( null, rawBaloonInfo);	
    aboutView.addControl( baloonLabel );
    	
	setupView = new ListView(null, LOC_setupTitle);	
	titleFormatList = new SelectionMenu(null, LOC_titleFormat, titleFormates, false);
	setupView.addControl(titleFormatList);	
	dateFormatList = new SelectionMenu(null, LOC_dateFormat, dateFormates, false);
	setupView.addControl(dateFormatList);
				
	miniView = new HomeScreenView( null );
		
    updateTimerId = setInterval( updateTimerFunc, 60 * 60 * 1000 ); // 1   
    
	sizeState = isHSViewMode();
		
    openAndRead();	
}

function updateTimerFunc()
{
    if( uiManager.getView() == mainView || uiManager.getView() == miniView ) 
        openAndRead();	
}

function showMainView(){
    setMainViewSoftkeys();
    uiManager.setView(mainView);
}

function setMainViewSoftkeys(){
    if (window.widget) {
        menu.setRightSoftkeyLabel("", null);
        menu.clear();
        
        var aboutMenuItem = new MenuItem(LOC_mnuAbout, MENU_ITEM_ABOUT);
        aboutMenuItem.onSelect = menuItemSelected;
        menu.append(aboutMenuItem);
        
        var setupMenuItem = new MenuItem(LOC_mnuSetup, MENU_ITEM_SETUP);
        setupMenuItem.onSelect = menuItemSelected;
        menu.append(setupMenuItem);
        
        var refreshMenuItem = new MenuItem(LOC_mnuRefresh, MENU_ITEM_REFRESH);
        refreshMenuItem.onSelect = menuItemSelected;
        menu.append(refreshMenuItem);
    }
}


// Callback for when menu items are selected.
function menuItemSelected(id){
    switch (id) {
        case MENU_ITEM_ABOUT:
            showAboutView();
            break;
        case MENU_ITEM_REFRESH:
            openAndRead();
            break;
        case MENU_ITEM_SETUP:
            showSetupView();
            break;
    }
}

function showAboutView(){
    setAboutViewSoftkeys();
    uiManager.setView(aboutView);
}

function setAboutViewSoftkeys(){
    if (window.widget) {
        menu.setRightSoftkeyLabel("", null);
        menu.clear();
        menu.setRightSoftkeyLabel("OK", showMainView);
    }
}

function openAndRead(){
	
    if (phonebook == null) 
        try {
            phonebook = device.getServiceObject("Service.Contact", "IDataSource");
        } 
        catch (err) {
            alert(LOC_unableToReadContacts);
            return;
        }
    
    
    var criteria = new Object();
    criteria.Type = 'Contact';
    
    try {
        phonebook.IDataSource.GetList(criteria, calc_persons);
    } 
    catch (err) {
        alert(LOC_errorWhileReadingContacts);
        return;
    }
    
    if( !isHSViewMode() )
        uiManager.showNotification(-1, "wait", LOC_readingContacts, -1);
}


function calc_persons(transId, eventCode, result)
{
    //2 - Event completed
    if (eventCode != 2) 
        return;

    for (var i = 0; i < persons.length - 1; i++) 
        persons[i] = null;

    persons = [];
    
    var totalCount = 0;
    
    if (result.ErrorCode != 0) {
        if (result.ErrorCode != 1012) { // no items ?
            uiManager.hideNotification();
            alert(result.ErrorMessage);
        }
    }
    else {
        var item;
        var it = result.ReturnValue;
        
        var cur = new Date();
        
        while ((item = it.getNext()) != undefined) {
            if ( item.Date != null && (item.LastName != undefined || item.FirstName != undefined || item.CompanyName != undefined)) {
                var x = date_parse(item.Date.Value);
                if (x != null) {
                    var p = new Person(item, x.getDate(), x.getMonth(), x.getFullYear());
                    p.calcW(cur.getDate(), cur.getMonth(), cur.getFullYear());
                    persons.push(p);
                }
            }
            item = null;
        }
        it.reset();
        it = null;
        
        
        for (var i = 0; i < persons.length - 1; i++) 
            for (var j = i + 1; j < persons.length; j++) 
                if (persons[j].w < persons[i].w) {
                    var tmp = persons[i];
                    persons[i] = persons[j];
                    persons[j] = tmp;
                }
        
        
    }
    showData();
}


function showSetupView(){
	
	var x = titleFormatList.getOptionForValue( setup_titleFormat );
	titleFormatList.setSelected(x);
	
	x = dateFormatList.getOptionForValue( setup_dateFormat );
	dateFormatList.setSelected(x);
	
    setSetupViewSoftkeys();
    uiManager.setView(setupView);
}

function setSetupViewSoftkeys(){
    if (window.widget) {
		menu.setRightSoftkeyLabel("OK", setup_saveAndShowMain);
		
		menu.clear();
		var cancelMenuItem = new MenuItem(LOC_mnuCancel, MENU_ITEM_CANCEL);
		cancelMenuItem.onSelect = showMainView;
		menu.append(cancelMenuItem);
    }
}

function setup_saveAndShowMain()
{
    setup_titleFormat = titleFormatList.getSelected().value;	
    setup_dateFormat  = dateFormatList.getSelected().value;
	
    titleFormat = setup_titleFormat;
    dateFormat  = setup_dateFormat;

	widget.setPreferenceForKey( titleFormat, "titleFormat" );
	widget.setPreferenceForKey( dateFormat,  "dateFormat" );
	
	openAndRead();
}



function isHSViewMode(){
	var screenHeight = window.innerHeight;
	return screenHeight < 150; // HS_VIEW_TRESHOLD
}

function showData()
{

   if( isHSViewMode() ) 
   {
   	   var p1 = "", p2 = "", p3 = "";
	   var count = 0, p0;
	   var baloon = "baloon_long.png";
       for( var i = 0; i < persons.length; i++ ) 
	   {
	       var p = persons[i];
		   
		   var title = p.birthDay( dateFormat ) + " "; 
		   var pTitle = p.personTitle( titleFormat );
		   if( pTitle.length > 18 ) {
		   	  pTitle = pTitle.substring(0, 18);
			  pTitle += "...";			  
		   }
		   title += pTitle;
		   		   
		   if (count == 0)
		   	p1 = title;
		   else 
		   	if (count == 1)
		   		p2 = title;
		   	else 
		   		if (count == 2) 
		   			p3 = title;

           if (count == 0) {
		   	p0 = p;
		   	if (p.w > 21) 
		   		baloon = "baloon_long.png";
		   	else 
		   		if (p.w <= 21 && p.w > 7) 
		   			baloon = "baloon_middle.png";
		   		else 
		   			if (p.w <= 7) 
		   				baloon = "baloon.png";
		   }
			
		   count++;
		   if( count > 2 )
		       break;				   
	   }
	   
	   var raw = "<TABLE BACKGROUND=\"bg.jpg\"; width=312 height=82 border=0 style=\"font-size: 18px;\">" +  
	             "<TR> <TD rowspan=3 width=40px><img src=\"" + baloon + "\" alt=\"baloon\" align=\"center\"/></TD>";
				 
	   if(count > 0 )
	   {
	   	if( p0.w == 0 )
           raw += "<TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; font-weight: bold; color: red;\">" + p0.personTitle( titleFormat ) + "</TD></TR>"  +
				  "<TR><TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; font-weight: bold; color: red;\">" + LOC_birthDay + p0.birthDay( dateFormat ) + "</TD></TR>" + 
				  "<TR><TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; font-weight: bold; color: red;\">" + LOC_age + p0.age + "</TD></TR></TABLE>"; 
		else
           raw += "<TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; color: black;\">" + p1 + "</TD></TR>" + 
				  "<TR><TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; color: black;\">" + p2 + "</TD></TR>" + 
				  "<TR><TD nowrap=\"true\" align=\"left\" style=\"font-size: 18px; color: black;\">" + p3 + "</TD></TR></TABLE>"; 
	   }				  
	   else
           raw += "<TD rowspan=3 align=\"center\">" + LOC_suitableContactsNotFound + "</TD></TR></TABLE>"; 
	       			  
   	   miniView.setRowHtml( raw ); 
	
	
       uiManager.setView(miniView);	
   }
   else
   {
        for (var i = 0; i < buttons.length; i++)
            mainView.removeControl(buttons[i]);
        buttons = [];
		
		var totalCount = 0;

        for( var i = 0; i < persons.length; i++ ) 
        {
	        var p = persons[i];
	        var cap = p.personTitle( titleFormat ) + "<br>" + LOC_birthDay + p.birthDay( dateFormat ) + "<br>" + LOC_age + p.age;
			
			if( p.w > 0 )
			    cap += ", " + LOC_days_until_bd + p.w ;
	            
	        var baloon;
	        if(p.w > 21) 
	            baloon = "baloon_long.png";
	        else 
	            if(p.w <= 21 && p.w > 7) 
	                baloon = "baloon_middle.png";
	            else 
	                if(p.w <= 7) 
	                    baloon = "baloon.png";
            
            
	        var itemControl = new NavigationButton(null, baloon, cap, p.w == 0);
	        mainView.addControl(itemControl);
	        buttons.push(itemControl);
        	totalCount++;
        }

        uiManager.hideNotification();
        if (totalCount == 0) 
			alert(LOC_suitableContactsNotFound);
        showMainView();
		
   }
    
}

function onResize()
{
	var x = isHSViewMode();		
	if (x != sizeState) 
	{
        sizeState = x;	
		showData();
	}	
}
